local buffs = {
	["199603"] = true, -- Gezinkte Würfel/Jolly Roger
	["193358"] = true, -- Handgemenge/Grand Melee
	["193357"] = true, -- Haiverseuchte Gewässer/Shark Infested Waters
	["193359"] = true, -- Kurs halten/True Bearing
	["199600"] = true, -- Vergrabener Schatz/Buried Treasure
	["193356"] = true, -- Breitseiten/Broadsides
}

local rolls = 0
local EventFrame = CreateFrame("Frame")
-- Addon initialization
EventFrame:RegisterEvent("ADDON_LOADED")
EventFrame:SetScript("OnEvent", function(self, event, ...)
	if(event == "ADDON_LOADED") then
		-- Only load addon if current class is rogue
		classDisplayName, class, classID = UnitClass("player")
		if(classID == 4) then
			-- Set event handler for talent switch
			EventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
			-- Initialize saved variables if called for the first time
			SetStandardValues()
			local currentSpecIndex = GetSpecialization()
			local currentSpecId = currentSpecIndex and select(1, GetSpecializationInfo(currentSpecIndex)) or "None"
			if(currentSpecId == 260) then
				EventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
			end
		end
	end
	
	if(event == "ACTIVE_TALENT_GROUP_CHANGED") then
		if(GetSpecializationInfo(GetSpecialization()) == 260) then
			EventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		else
			EventFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		end
	end
	
	if(event == "UNIT_SPELLCAST_SUCCEEDED") then
		local unit = ...
		local unitID, spell, rank, lineID, spellID = select(1, ...)
		if(unit ~= "player" or spellID ~= 193316) then -- Check if player rolled the bones: return if not
			return
		end
		local amount = 0 -- Number of buffs active
		rolls = rolls + 1
		for buff in pairs(buffs) do       
			if(UnitBuff("player", GetSpellInfo(buff))) then
				amount = amount + 1
			end
		end
		if(amount > 1) then
			if(rolls >= TTBDB.threshold) then -- Message after ending the bad luck streak
				SendChatMessage(string.gsub(TTBDB.finallyMessage, '{n}', rolls), "yell")
				-- Update record
				if(rolls > TTBDB.record) then
					TTBDB.record = rolls
				end
			end
			rolls = 0
		end
		if(amount == 6) then -- Message for six buffs
			SendChatMessage(TTBDB.hamMessage, "yell")
			rolls = 0
			-- Play Leeroy
			if(TTBDB.leeroy == true) then
				PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\leeroy-jenkins.ogg", "Master")
			end
		end
		-- Play sounds
		if(TTBDB.playsound == true) then
			if(amount == 1) then
				PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\1-one.ogg", "Master")
			elseif(amount == 2) then
				PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\2-two.ogg", "Master")
			elseif(amount == 3) then
				PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\3-three.ogg", "Master")
			elseif(amount == 6) then
				if(TTBDB.leeroy == false) then
					PlaySoundFile("Interface\\AddOns\\TrollTheBones\\sounds\\6-six.ogg", "Master")
				end
			end
		end
	end
end)

-- Set standard saved variables
function SetStandardValues()
	if(TTBDB == nil) then
		TTBDB = {}
	end
	if(not TTBDB.hamMessage) then
		TTBDB.hamMessage = "I rolled 'em all. Pulling Azeroth NOW!"
	end
	if(not TTBDB.finallyMessage) then
		TTBDB.finallyMessage = "I was just trolled by the bones {n} times."
	end
	if(not TTBDB.threshold) then
		TTBDB.threshold = 5
	end
	if(not TTBDB.playsound) then
		TTBDB.playsound = false
	end
	if(not TTBDB.leeroy) then
		TTBDB.leeroy = false
	end
	if(not TTBDB.record) then
		TTBDB.record = 0
	end
end

-- Slash commands
SLASH_TTB1 = '/ttb'
function SlashCmdList.TTB(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	if(command == "ham" and rest ~= "") then
		print("Ham message set to: " .. rest)
		TTBDB.hamMessage = rest
	elseif(command == "ham" and rest == "") then
		print("Ham message currently is: " .. TTBDB.hamMessage)
	elseif(command == "finally" and rest ~= "") then 
		print("Finally message set to: " .. rest)
		TTBDB.finallyMessage = rest
	elseif(command == "finally" and rest == "") then
		print("Finally message currently is: " .. TTBDB.finallyMessage)
	elseif(command == "threshold" and rest ~= "" and tonumber(rest) ~= nil and tonumber(rest) > 0) then
		print("Threshold set to: " .. rest);
		TTBDB.threshold = tonumber(rest)
	elseif(command == "threshold" and rest == "") then
		print("Threshold currently is: " .. TTBDB.threshold)
	elseif(command == "playsound" and rest == "") then
		print("Sound output currently is set to: " .. tostring(TTBDB.playsound))
	elseif(command == "record" and rest == "") then
		print("Your current record of rerolling is: " .. TTBDB.record)
	elseif(command == "playsound" and (rest == "false" or rest == "true")) then
		if(rest == "true") then
			TTBDB.playsound = true
		elseif(rest == "false") then
			TTBDB.playsound = false
		end
		print("Sound output set to: " .. tostring(TTBDB.playsound))
	elseif(command == "leeroy" and rest == "") then
		print("Leeroy mode currently is set to: " .. tostring(TTBDB.leeroy))
	elseif(command == "leeroy" and (rest == "true" or rest == "false")) then
		if(rest == "true") then
			TTBDB.leeroy = true
		elseif(rest == "false") then
			TTBDB.leeroy = false
		end
		print("Leeroy mode set to: " .. tostring(TTBDB.leeroy))
	end
end